//-------------------------------------------------------------------------
//
//   DELL COMPUTER CORPORATION PROPRIETARY INFORMATION
//This software is supplied under the terms of a license agreement or
//nondisclosure agreement with Dell Computer Corporation and may not
//be copied or disclosed except in accordance with the terms of that
//agreement.
//
//  Copyright (c) 2011-2012 Dell Computer Corp. All Rights Reserved.
//
//Abstract/Purpose:
//
//Environment: 
//
//$Author:$ 
// 
//$Header:$  
// 
//$Date:$  6/24/2012 11:34:14 AM
// 
//$Name:$  CDeviceInfo.h
// 
//$Revision:$ 
// 
//$Source:$  
// 
//Owner: Chandrasekhar G, Vinay Krishna
// 
//-------------------------------------------------------------------------
#ifndef _CDEVICEINFO_H_INCLUDED_
#define _CDEVICEINFO_H_INCLUDED_
#include <iostream>
#include <string>
#include "Common.h"
using namespace std;
struct SPCIInfo
{
	string m_strCompID;
	string m_strDeviceID;
	string m_strSubDeviceID;
	string m_strVendorID;
	string m_strSubVendorID;
	string m_strMarketingName;
	
};
 typedef struct _BDFInfo {
	unsigned char u8Bus;
	unsigned char u8Dev;
	unsigned char u8Fun;
 } BDFInfo;
class CDeviceInfo
{
	
public : 
	enum eDeviceType {UNKNOWN_DEVICE=0, PCI_DEVICE=1, NON_PCI_DEVICE=2};
	enum eDependencyType {NODEP=0, HARD=1, SOFT=2};
private :
	string			m_strReleaseID;
	string			m_strComponentID;
	string			m_strParentComponentID;
	string			m_componentType;
	string			m_strDeviceName;
	string			m_strVersion;
	struct SPCIInfo	m_PCIInfo;
	eDeviceType		m_deviceType;
	eDependencyType	m_dependencyType;
	int				m_msgID;
	int				m_nStatus;
	string			m_strErrMsg;
	int             m_nUpdateStatus;
	string			m_strDisplay;
	string			m_strDetail;
	string			m_strFilePath;
	string			m_strCurrentVersion;
	string			m_strEnumID;
	bool 			m_bRebootRequired;
	BDFInfo			m_SBDFInfo;
	
public:
	 
	 CDeviceInfo();
	~CDeviceInfo();
	string getComponentID(void);
	string getErrorMsg();
	string getComponentType(void);
    string getDeviceName(void);
	string getVersion(void);
	struct SPCIInfo getPCIInfo(void);
	BDFInfo getBDFInfo(void);
	int getUpdateStatus();
	eDeviceType getDeviceType(void);
	eDependencyType getDependencyType(void);
	int getMessageID(void);
	int  getStatus();
	string getDisplay();
	string getDetail();
	string getFilePath();
	string getReleaseID();
	string getParentComponentID();
	string getCurrentVersion();
	string getEnumId();
	bool getRebootRequired();
	

	void setComponentType(string);
	void setComponentID(string);
	void setDeviceName(string);
	void setVersion(string);
	void setPCIInfo(struct SPCIInfo);
	void setPCIInfo(unsigned short devID,unsigned short  subDevID,unsigned short  venID,unsigned short  subVenID);
	void setBDFInfo(BDFInfo);
	void setBDFInfo(unsigned char bus,unsigned char dev,unsigned char fun);
	void setDeviceType(eDeviceType);
	void setDependencyType(eDependencyType);
	void setMessageID(int);
	void setErrorMsg(string);
	void setStatus(int);
	void setUpdateStatus( int nUpdateStatus);
	void setDisplay(string);
	void setDetail(string);
	void setFilePath(string);
	void setReleaseID(string);
	void setParentComponentID(string);
	void setCurrentVersion(string);
	void setEnumId(string);
	void setRebootRequired(bool bRebootRequired);
	bool operator== (const CDeviceInfo devInfo);
};

#endif
