//-------------------------------------------------------------------------
//
//   DELL COMPUTER CORPORATION PROPRIETARY INFORMATION
//This software is supplied under the terms of a license agreement or
//nondisclosure agreement with Dell Computer Corporation and may not
//be copied or disclosed except in accordance with the terms of that
//agreement.
//
//  Copyright (c) 2011-2012 Dell Computer Corp. All Rights Reserved.
//
//Abstract/Purpose:
//
//Environment: 
//
//$Author:$ 
// 
//$Header:$  
// 
//$Date:$  6/24/2012 11:34:14 AM
// 
//$Name:$  IPlatfomrImpl.h
// 
//$Revision:$ 
// 
//$Source:$  
// 
//Owner: Chandrasekhar G, Vinay Krishna
// 
//-------------------------------------------------------------------------

#ifndef __IPLATFORMIMPL__
#define __IPLATFORMIMPL__ 
#include "ErrorCodes.h"
#include <vector>
#define MAX_PATH_SIZE 2048

class IPlatformImpl
{

public:
	IPlatformImpl(){};
	~IPlatformImpl(){};
	virtual bool  isHAPIInstalled()=0;
	virtual ePlatformRC InstallHapi()=0;
	virtual ePlatformRC UninstallHapi()=0;
	virtual void* LoadLibrary(const std::string &strLibraryName)=0;
	virtual void FreeLibrary(void* hLib) =0;
	virtual void* GetProcAddress(void *hLib, const std::string& strFunctionName)=0;
	virtual int ExecuteCmd(const std::string & strCommand, bool bVerboseMode =false, const long &nTimeout=300000) = 0;
	virtual int ExecuteCmdNoWait(const std::string & strCommand, bool bVerboseMode =false,const long &nTimeout=300000) = 0;
	virtual void Sleep(int nSeconds) = 0;
	virtual std::string getCurrentDirectory() = 0;
	virtual std::string getCurrentProcessDirectory() = 0;
	virtual bool setCurrentDirectory(const std::string &) = 0;
	virtual std::vector<std::string> GetFileList(std::string &strDirName) =0;
	virtual bool IsFileExits(const std::string &strFileName)=0;
	virtual bool IsFileExistsAbs(const std::string &strFileName)=0;
	virtual void* LoadHapiLibrary(const std::string & strFileName)= 0 ;
	virtual bool isUSBblacklisted()=0;
};
#endif
