//--------------------------------------------------------------------
//
//          DELL COMPUTER CORPORATION PROPRIETARY INFORMATION
// This software is supplied under the terms of a license agreement or
// nondisclosure agreement with Dell Computer Corporation and may not
// be copied or disclosed except in accordance with the terms of that
// agreement.
//
// Copyright (c) 1995-2011 Dell Computer Corporation. All Rights Reserved.
// 
//
// Abstract/Purpose:
//
// Header file to enumerate devices on linux operating system
//
// Environment:
//
// Linux
//
//---------------------------------------------------------------------
#ifndef __ENUMERATEDEVICES_H__
#define __ENUMERATEDEVICES_H__
#include <scsi/sg.h>
#include <scsi/scsi.h>
#include <vector>
#include <map>

class CLinuxEnumerateDevices
{
	typedef struct sg_device_info
	{
		struct sg_scsi_id sg_data;
		std::string sdDeviceName;
	}sg_device_info;
	typedef struct scsi_idlun 
	{
		int dev_id;
		int host_unique_id;
	}scsi_idlun;

	std::map<std::string,sg_device_info> m_deviceInfo;
	std::vector<std::string> m_sgDevices;
	bool m_bScanAllDevices;
public:
	CLinuxEnumerateDevices();
	CLinuxEnumerateDevices(bool bScanAllDevices);
	~CLinuxEnumerateDevices();
	bool GetDeviceWithLabel(const std::string &strLabel,std::string &strDeviceName);
private:
 	bool GetAllSGDevices(); 
	bool GetEumlatedSGDevices();
	bool GetSDDevices();
	bool SearchSGDevice(std::string strDevice,scsi_idlun& idlun,int host_no);
	void MakeDeviceName(char * fname, const char * leadin, int k, int do_numeric);
};

#endif
