
#ifndef __CLINUXIMPL__
#define __CLINUXIMPL__ 

#include "IPlatformImpl.h"
#define HAPI_INSTALL   "/dupdisneyinstall.sh install"
#define HAPI_UNINSTALL "/dupdisneyinstall.sh uninstall"
#define PATH_SEPARATOR "/"
#if defined __x86_64 || _LP64
	#define DCHIPMMODULE2	"libdchipm64.so"
	#define HAPI_DUP_PATH "/opt/dell/dup64/lib/"
#else
	#define DCHIPMMODULE2	"libdchipm32.so"
	#define HAPI_DUP_PATH "/opt/dell/dup/lib/"
#endif
#define HAPI_DUP_PATH_ESXI "/scratch/opt/dell/dup/lib/"
#define DCHIPMMODULE	"libdchipm.so"


class CLinuxImpl :public IPlatformImpl
{
	static bool bHAPIAlreadyInstalled;
	static int nHAPIInstallRefCount;
public:
	CLinuxImpl(void);
	~CLinuxImpl(void);
	bool isHAPIInstalled();
	ePlatformRC InstallHapi();
	ePlatformRC UninstallHapi();
	void* LoadLibrary(const std::string &strLibraryName);
	void FreeLibrary(void* hLib);
	void* LoadHapiLibrary(const std::string&);
	void* GetProcAddress(void *hLib, const std::string& strFunctionName);
	int ExecuteCmd(const std::string & strCommand, bool bVerboseMode =false, const long int& nTimeOut = 0);
	int ExecuteCmdNoWait(const std::string & strCommand, bool bVerboseMode =false, const long int& nTimeOut = 0);
	virtual void Sleep(int nSeconds) ;
	virtual std::string getCurrentDirectory();
	virtual std::string getCurrentProcessDirectory();
	virtual bool setCurrentDirectory(const std::string &strCurrentDir);
	virtual std::vector<std::string> GetFileList(std::string &strDirName);
	bool IsFileExits(const std::string & strFileName);
	bool IsFileExistsAbs(const std::string & strFileName);
	bool isESXiSystem(void);
	bool isUSBblacklisted(void);	
	
private:
	bool isOMSAHAPIInstalled();
	bool isUSBblacklistedusingConfFile();
	bool isESXSystem(void);
};
#endif
