//-------------------------------------------------------------------------
//
//   DELL COMPUTER CORPORATION PROPRIETARY INFORMATION
//This software is supplied under the terms of a license agreement or
//nondisclosure agreement with Dell Computer Corporation and may not
//be copied or disclosed except in accordance with the terms of that
//agreement.
//
//  Copyright (c) 2011-2012 Dell Computer Corp. All Rights Reserved.
//
//Abstract/Purpose:
//
//Environment: 
//
//$Author:$ 
// 
//$Header:$  
// 
//$Date:$  6/24/2012 11:34:14 AM
// 
//$Name:$  PlatformLayer.h
// 
//$Revision:$ 
// 
//$Source:$  
// 
//Owner: Chandrasekhar G, Vinay Krishna
// 
//-------------------------------------------------------------------------

#ifndef __CPLATFORMLAYER__
#define __CPLATFORMLAYER__

#include "ErrorCodes.h"
#include <vector>

class IPlatformImpl;
class CPlatformLayerTester;


class CPlatformLayer
{
	friend class CPlatformLayerTester;
	static IPlatformImpl *m_pPlatformImpl;
	static IPlatformImpl *GetPlatform();
	
public:
	CPlatformLayer(void);
	~CPlatformLayer(void);
	static bool  isHAPIInstalled();
	static ePlatformRC InstallHapi();
	static ePlatformRC UninstallHapi();
	static void* Load_Library(const std::string & strLibraryName);
	static void FreeLibrary(void* hLib);
	static void* GetProcAddress(void *hLib, const std::string& strFunctionName);
	static int ExecuteCmd(const std::string & strCommand, bool bVerboseMode =false,const long &nTimeout=300000);
	static int ExecuteCmdNoWait(const std::string & strCommand, bool bVerboseMode =false,const long &nTimeout=300000);
	static void Sleep(int nSeconds) ;
	static std::string getCurrentDirectory() ;
	static std::string getCurrentProcessDirectory();
	static bool setCurrentDirectory(const std::string &) ;
	static std::vector<std::string> GetFileList(std::string &strDirName) ;
	static bool IsFileExits(const std::string &strFileName);
	static bool IsFileExistsAbs(const std::string &strFileName);
	static void* LoadHapiLibrary(const std::string & strFileName) ;
	static bool isUSBblacklisted();
};

#endif
