////////////////////////////////////////////////////////////////////////////////////////////////////
//          DELL COMPUTER CORPORATION PROPRIETARY INFORMATION    
// This software is supplied under the terms of a license agreement or
// nondisclosure agreement with Dell Computer Corporation and may not
// be copied or disclosed except in accordance with the terms of that
// agreement.

// Copyright (c) 2013-2014 Dell Computer Corp. All Rights Reserved.

// \Abstract/Purpose:

// \Date: 6/17/2013 11:06:46 PM

// \FileName: SoftwareComponentInfo.h

// \Auther: krishna_vinay

////////////////////////////////////////////////////////////////////////////////////////////////////


#ifndef __SOFTWARECOMPONENTINFO_H_INCLUDES__
#define __SOFTWARECOMPONENTINFO_H_INCLUDES__


 ///////////////////////////////////////Includes/////////////////////////////////////////////////////
#include "PlatformLayer.h"
#include <map>

#if defined SYSTEM_TYPE_WINNT
	#include <external\\DeviceInfo.h>
#elif SYSTEM_TYPE_LINUX
	#include <external/DeviceInfo.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

#if defined SYSTEM_TYPE_WINNT
	#include <libxml\\xmlmemory.h>
	#include <libxml\\parser.h>
	#include <libxml\\xpath.h>
	#include <libxml\\tree.h>
	#include <libxml\\parser.h>
	#include <libxml\\xmlschemastypes.h>
	#include <libxml\\valid.h>
	#include <libxml\\xmlschemas.h>
#elif SYSTEM_TYPE_LINUX
	#include <libxml/xmlmemory.h>
	#include <libxml/parser.h>
	#include <libxml/xpath.h>
	#include <libxml/tree.h>
	#include <libxml/parser.h>
	#include <libxml/xmlschemastypes.h>
	#include <libxml/valid.h>
	#include <libxml/xmlschemas.h>
#endif

#ifdef __cplusplus
}
#endif


 ///////////////////////////////////////Constants/////////////////////////////////////////////////////
#define PACKAGEXML			"package.xml"
#define PCIINFO				"PCIInfo"
#define COMPONENTID			"componentID"
#define DEVICEID			"deviceID"
#define SUBDEVICEID			"subDeviceID"
#define SUBVENDORID			"subVendorID"
#define VENDORID			"vendorID"
#define SUPPORTEDDEVICES	"//SoftwareComponent/SupportedDevices/Device"
#define COMPONENTTYPE		"//SoftwareComponent/ComponentType"
#define SOFTWARECOMPONENT	"//SoftwareComponent"
#define DISPLAY				"Display"

const std::string QUERYCOMPID	("/SVMInventory/Device[@componentID = \"");
const std::string XPATH_SUFFIX	("\"]");

///////////////////////////////////////Forwards Declarations/////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////////////

/// \class  CSoftwareComponentInfo
///
/// \brief  Additional information about class. 
///
////////////////////////////////////////////////////////////////////////////////////////////////////

class CSoftwareComponentInfo
{	
	friend class CSoftwareComponentTester;
	std::string m_strFileName;
	xmlDocPtr m_pDocXml;
	private:
		void ParseXMl();
		std::map<std::string, std::string> getCompIDMarkNameInfo();
	public:
		CSoftwareComponentInfo();
		CSoftwareComponentInfo(std::string);
		~CSoftwareComponentInfo();	
		std::string GetComponentID();		
		xmlXPathObjectPtr ParseXmlUsingXpath();
		xmlXPathObjectPtr ParseXmlUsingXpath(char* pXpathExpr);
		xmlXPathObjectPtr GetNodeSet(xmlDocPtr, xmlChar *);
		std::vector<SPCIInfo> GetSupportedDevices();
		char* GetAttributeValue(xmlNodePtr cur, const char *propName);
		std::string GetComponentType();
		std::string GetComponentVersion();
		xmlXPathObjectPtr getnodeset( xmlDocPtr doc, xmlChar * xpath );
		bool GetInvFromLCL(std::string componentID, std::stringstream &InvXML,std::stringstream &lclInv);
		std::vector<class CDeviceInfo *> getDependencyInfo();
		void AddDependencyInfo(std::vector<class CDeviceInfo *> &vectDepInfo, class CDeviceInfo* &pDepInfo);
		std::string GetComponentDisplayString();	
		std::string getMarketingNameForPCIDevice(SPCIInfo &keyPCIInfo);
		std::string getMarketingNameForNonPCIDevice(std::string &strCompID);
		bool getPresenceOfRollbackInfo();
};


#endif //__SOFTWARECOMPONENTINFO_H_INCLUDES__

