#ifndef _SMAL_ERROR_H
#define _SMAL_ERROR_H
#ifndef _STDINT_H
typedef unsigned char  uint8_t;
#endif // _STDINT_H

// Throw error codes 
const uint8_t SMAL_OK_CODE			=    0; // request executed successfully.
const uint8_t SMAL_IPMIERROR		=    1; // An IPMI command failed for which there is no specific return code
const uint8_t SMAL_NOMASERSESS		=    2; // Request was made without creating a session.
const uint8_t SMAL_INVMASERPART		=    3; // Request contained an invalid partition (> 16)
const uint8_t SMAL_PARTSIZESMALL	=    4; // Dynamic partition size is too small
const uint8_t SMAL_GETSESSFAIL		=    5; // BeginMaserSession call failed...
const uint8_t SMAL_NOSRCFILE		=    6; // AddFile was called without a source file
const uint8_t SMAL_NODESTFILE		=    7; // AddFile was called without a destination file
const uint8_t SMAL_SRCFILEMISSING	=    8; // stat of the file failed Path is wrong, or file is missing
const uint8_t SMAL_ADDORDERERROR	=    9; // AddFile was called before StartCopyFile
const uint8_t SMAL_DIRISEMPTY		=   11; // the Maser directory colud not be found
const uint8_t SMAL_EWRONGORDER		=   12; // a functinon was called out of order.
const uint8_t SMAL_HASHMISMATCH		=   13; // The origianl file hashe does not match the copied file
const uint8_t SMAL_NODYNPRESENT		=   14; // Attachment of the dynamic partition failed.
const uint8_t SMAL_INSTIPMIERROR	=   15; // IPMI install failed 
const uint8_t SMAL_HAPINOTPRES		=   16; // the hapi package is not present
const uint8_t SMAL_NOINSTANCE		=   17; // A method has been called without instantiating the object. 
const uint8_t SMAL_NOSUCHREQUEST	=   18; // The IPMI request does not exist.
const uint8_t SMAL_INVPARTNAME		=   19; // Name doesn't end with a 3 digit number.
const uint8_t SMAL_NOMASERPRESENT	=   20; // Maser is not presetn or is broken.
const uint8_t SMAL_MASERDISABLED	=   21; // User Has turned off maser access.
const uint8_t SMAL_DYNPARTERR		=   22; // Creation of the dynamic partition failed.
const uint8_t SMAL_DETACHFAILED		=   23; // Detaching a partition failed.
const uint8_t SMAL_SMCFAILED		=   24; // Secure Maser Copy Failed. 
const uint8_t SMAL_DELETEDROPBOXERR	=	25; // Delete Drop  box failed.
const uint8_t SMAL_READWRITEERR		=	26; // set partition mode ipmi command failed
const uint8_t SMAL_FINDMOUNTERR		=	27; // Could not find where the dynamic partition was mounted.
const uint8_t SMAL_CMDTIMEDOUT		=	28; // IPMI command timed out
const uint8_t SMAL_SESSIONACTIVE	=	29; // A session is already present.
const uint8_t SMAL_ENDSESSERR		=	30; // End Maser session fialed.
const uint8_t SMAL_INTERROR			=	31; // An internal library error has occurred.
const uint8_t SMAL_INVLCLREQ		=	32; // An invalid update LCL request was made.
const uint8_t SMAL_NOFILEFOUND		=	33; // An invalid update LCL request was made.
const uint8_t SMAL_GETSTATFAIL		=	34; // Get Status command failed.
const uint8_t SMAL_DYNPARTEXISTS	=	35; // Dynamic partition with SECUPD name already exists.
const uint8_t SMAL_SIZEGT2GB		=	36; // Request for dynamic partition greater than 2GB.
const uint8_t SMAL_ATTACHPARTFAIL	=	37; // attach partition failed.
const uint8_t SMAL_NOSPACEONMASER	=	38; // No space on Maser for copying.
const uint8_t SMAL_GOTNOHANDLE		=	39; // Unable to obtain handle for Volume.
const uint8_t SMAL_PARTNOTMOUNTED 	=	40; // partition not mounted.
const uint8_t SMAL_FINDVOLFAILED 	=	41; // FindFirstVolume failed.
const uint8_t SMAL_GETVOLINFO 		=	42; // GetVolumeInformation failed.
const uint8_t SMAL_FINDNEXTVOL 		=	43; // FindNextVolume failed.
const uint8_t SMAL_DELDYNPARTERR 	=	44; // delete dynamic partition failed.
const uint8_t SMAL_GMASFAILED 		=	45; // The getMaserAccessState IPMI command failed.
const uint8_t SMAL_HAPIINSTALLERROR =   46; // The attempt to install HAPI failed
const uint8_t SMAL_COPYVERIFYFAIL	=	47; // The file copied to the maser did not match the original file.
const uint8_t SMAL_GETSTATEERROR	=	48; // The getStateFlag command failed.
const uint8_t SMAL_SETSTATEERROR	=	49; // The setStateFlag command failed.
const uint8_t SMAL_RESEXTCFG		=	50; // Reserved Extended Configuration Command failed.
const uint8_t SMAL_SETEXTCFG		=	51; // Set Extended Configuration command failed (Reset iDRAC) to
const uint8_t SMAL_UNSUPPORTEDOS	=	52; //The OS is unsupported by this release
const uint8_t SMAL_PACKAGEXMLERROR	=	53; // Error retrieving component id from package.xml.
const uint8_t SMAL_INVALID_QUERY    =   54; //doDepCheck called with invalid query type
const uint8_t SMAL_MASER_DISABLED   =   55; //MASER is disabled
const uint8_t SMAL_ESX_USBARBITRATOR_SERVICE_RUNNING  =   56; 
const uint8_t SMAL_SIGNFILEMISSING	 =   57; // stat of the sign file failed. Path is wrong, or file is missing
const uint8_t SMAL_PACKAGEXMLMISSING =   58; // stat of the package.xml failed. Path is wrong, or file is missing
const uint8_t SMAL_PAYLOADSIZEGTMAX	 =   59; //Payload size exceeds Maximum Dynamic partition size
const uint8_t SMAL_BEGIN_SECUREUPDATE_FAILED =   60; //Begin Secure Update Failed
const uint8_t SMAL_PROCESS_SECUREUPDATE_FAILED = 61; //Process Secure Update Failed
const uint8_t SMAL_END_SECUREUPDATE_FAILED = 62; //End Secure Update Failed
const uint8_t SMAL_GETSESSFAIL_12G		=    63; // BeginMaserSession call failed... Same as SMAL_GETSESSFAIL
const uint8_t SMAL_CREATE_DYN_PART_FAILED	=    64; // BeginMaserSession call failed... Same as SMAL_GETSESSFAIL
const uint8_t SMAL_USB_BLACKLISTED = 65;
#endif /* _SMAL_ERROR_H */
