#ifndef UPDROLLBACK_H
#define UPDROLLBACK_H

//#include <secureMaser.h>
#include "smal.h"
#include <vector>

using namespace std;

const string ssibFile = "ssibinput.xml";
const string mas022_lower = "mas022";
const string pkgFile = "package.xml";
const string NDir = "current";
const string N_1Dir = "previous";
const string secureMaserError = "Could not create Secure Maser object";
const string secureMaserSuccess = "Secure Maser initialized successfully";
const string maserNotpresent = "Full Maser not found on the system";
const string secureInitError = "Could not initialize Secure Maser";
const string startcopyError = "StartCopyFile Error : ";
const string startcopySuccess = "StartCopyFile done successfully";
const string noPayload = "No Files found in Payload Directory";
const string noHandleError = "Could not create handle to get files in Payload Directory";
const string statError = "Could not stat file ";
const string payload = " in the Payload Directory";
const string noCompID = "Could not get Component ID";
const string noOpen = "Could not open file ";
const string writing = " for writing";
const string addcompIDError = "Could not add component ID file to FileList";
const string addSSIBError = "Could not add SSIB file to FileList";
const string createFileListError = "Could not create FileList";
const string addError = "Could not add files to FileList";
const string createFileListSuccess = "FileList constructed successfully";
const string completeCopyError = "CompleteCopyFile Error : ";
const string copySuccess = "Payload copied and copy verified successfully";
const string endCopyError = "EndCopyFile Error : ";
const string noPKGHandleError = "Could not create handle to package.xml";
const string currentDirError = "Could not get current working directory";


#ifdef SYSTEM_TYPE_WINNT
	const string fileSeparator = "\\";
	//char fileSeparatorchar = "\\";
#else
	const string fileSeparator = "/";
#endif


typedef struct {
	string srcName;
	string dstName;
	xmlMode_t action;
} fDetails;

class UpdRollbackWrapper : public secureMaser
{
public:
	UpdRollbackWrapper();
	virtual ~UpdRollbackWrapper(void);
	int  addPayloadFiles(vector<string> payloadName, bool singleFile, bool bPackageXMLPathGiven=false, string strPackageXML="");  
	int  createComponentIdFile(string compName, string wrapperName, string destDir="");
	int  createSSIBUpdateFile(string wrapperName, string destDir="", string strSubSystem="");
	int  updateFirmwarePartition();
	int doRollbackAndUpdate(vector<string> abs_hdr_filename,char* subSystem,char *wrapperName,bool fileOrdirectory,string &strErrString,bool stageAndUpdate,bool bPackageXMLPathGiven=false,string strPackageXML="");
	int rollbackUsing13GMethod(vector<string> vecPayloadList, bool bSingleFile, string &strErrString, bool bStageAndUpdate,bool bPackageXMLPathGiven=false,string strPackageXML="");
	int rollbackUsing12GMethod(vector<string> abs_hdr_filename,char* subSystem,char *wrapperName,bool fileOrdirectory,string &strErrString,bool stageAndUpdate, bool bPackageXMLPathGiven=false,string strPackageXML="");
		
private:
	int  createFileList(vector<string> srcName, vector<fDetails *> &list, bool singleFile, bool bPackageXMLPathGiven=false, string strPackageXML="");
	int  addPayloadToFileList(string srcDir, string destCopyDir, vector<fDetails *> &list, bool singleFile); 
	void freeUpList(vector<fDetails *> &list);
	void  addToList(vector<fDetails *> &list, string srcName, string destName, exmlMode action);
	int  addPackageXMLToList(string srcDir, string destCopyDir, vector<fDetails *> &list,bool bPackageXMLPathGiven=false,string strPackageXML="");
	int updateFirmwarePartition13G(bool bStageAndUpdate);
	int addPayloadandPackageFiles(vector<string> payloadName, bool singleFile,bool bPackageXMLPathGiven=false,string strPackageXML="");
	string getDirectoryFromPath(string &path);
	string getFileNameFromPath(string &path);
	string getCurrentDir();
};
extern "C" {
        int UpdateBios12g_Using_USC(char* abs_hdr_filename,char* subSystem,char *wrapperName,bool fileOrdirectory,char *errString);
		int UpdateBios12g_Using_LC(vector<string> szAbHdrFilename, char* szSubSystem, char *szWrapperName, bool bSingleFile, char *szErrString);
}

#endif
